// 004 u_07_ansi_code_page
// 10 dec 2010

// -- (C) John COLIBRI 2010
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_07_ansi_code_page;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Grids;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    Panel4: TPanel;
    RichEdit1: TRichEdit;
    ListBox1: TListBox;
    Panel5: TPanel;
    Panel6: TPanel;
    Edit1: TEdit;
    Memo2: TMemo;
    convert_code_page_: TButton;
    raw_byte_string_: TButton;
    Splitter2: TSplitter;
    convert_unicode_ansi_: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Memo1: TMemo;
    TabSheet2: TTabSheet;
    StringGrid1: TStringGrid;
    ibm_437_: TRadioButton;
    default_1252_: TRadioButton;
    unicode_1200_: TRadioButton;
    Button1: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure convert_code_page_Click(Sender: TObject);
    procedure convert_unicode_ansi_Click(Sender: TObject);
    procedure raw_byte_string_Click(Sender: TObject);
    procedure ibm_437_Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
  uses Character, u_display_unicode;

{$R *.dfm}

    procedure display(p_text: String);
      begin
        Form1.Memo1.Lines.Add(p_text);
      end; // display

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        Memo1.Lines.Clear;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure do_display(p_string: String);
      var l_index: Integer;
      begin
        with Form1 do
        begin
          ListBox1.Items.Add(p_string);
          RichEdit1.Text:= RichEdit1.Text+ p_string;
          Memo2.Lines.Add(p_string);
          Edit1.Text:= Edit1.Text+ p_string;

          display(f_display_unicode_string(p_string));
          for l_index:= 1 to Length(p_string) do
            display(Format('%2d ', [l_index])+ p_string[l_index]);
        end; // with Form1
      end; // do_display

    procedure do_display_ansi_string(p_ansi_string: AnsiString);
      var l_index: Integer;
      begin
        with Form1 do
        begin
          ListBox1.Items.Add(p_ansi_string);
          RichEdit1.Text:= RichEdit1.Text+ p_ansi_string;
          Memo2.Lines.Add(p_ansi_string);
          Edit1.Text:= Edit1.Text+ p_ansi_string;

          display(f_display_ansi_string(p_ansi_string));
          for l_index:= 1 to Length(p_ansi_string) do
            display(Format('%2d %1x ', [l_index, Ord(p_ansi_string[l_index])])+ p_ansi_string[l_index]);
        end; // with Form1
      end; // do_display_ansi_string

    type t_ansi_ibm_oem= type AnsiString(437);

    procedure TForm1.convert_code_page_Click(Sender: TObject);
      var l_save_default_system_codepage: Word;

          l_ansi_ibm: t_ansi_ibm_oem;
          l_ansi_string: AnsiString;
      begin
        display('current default Ansi code page is '+ IntToStr(DefaultSystemCodePage));
        display('');
        l_save_default_system_codepage:= DefaultSystemCodePage;
        DefaultSystemCodePage:= 1252;

        l_ansi_ibm:= #$C6;
        display('ibm := $C6      :'+ l_ansi_ibm+ Format(' code_page %4d  Ord $%2x ', [ StringCodePage(l_ansi_ibm), Ord(l_ansi_ibm[1])]));

        l_ansi_string:= l_ansi_ibm;
        display('ansi := ibm     :'+ l_ansi_string+ Format(' code_page %4d  Ord $%2x ', [ StringCodePage(l_ansi_string), Ord(l_ansi_string[1])]));

        l_ansi_ibm:= l_ansi_string;
        display('ibm := ansi     :'+ l_ansi_ibm+ Format(' code_page %4d  Ord $%2x ', [ StringCodePage(l_ansi_ibm), Ord(l_ansi_ibm[1])]));

        DefaultSystemCodePage:= l_save_default_system_codepage;
      end; // ansistring_Click

    procedure TForm1.convert_unicode_ansi_Click(Sender: TObject);
      var l_save_default_system_codepage: Word;
          l_ansi_ibm: t_ansi_ibm_oem;
          l_unicode_string: String;
      begin
        l_save_default_system_codepage:= DefaultSystemCodePage;
        DefaultSystemCodePage:= 1252;

        l_ansi_ibm:= #$C6;
        display('ibm := $C6      :'+ l_ansi_ibm + Format(' code_page %4d  Ord $%2x ',
            [StringCodePage(l_ansi_ibm), Ord(l_ansi_ibm[1])]));

        l_unicode_string:= l_ansi_ibm;
        display('uni:= ibm       :'+ l_unicode_string+ Format(' code_page %4d  Ord $%2x ',
            [ StringCodePage(l_unicode_string), f_utf_16_at(l_unicode_string, 1)]));

        l_ansi_ibm:= l_unicode_string;
        display('ansi := uni     :'+ l_ansi_ibm + Format(' code_page %4d  Ord $%2x ',
            [StringCodePage(l_ansi_ibm), Ord(l_ansi_ibm[1])]));
      end; // display_hex_Click

    procedure TForm1.raw_byte_string_Click(Sender: TObject);
      var l_ansi_ibm: t_ansi_ibm_oem;
          l_ansi_string: AnsiString;
          l_raw_byte_string: RawByteString;
      begin
        DefaultSystemCodePage := 1252;

        l_raw_byte_string:= #$C6;
        display('raw:= #$C6     :'+ l_raw_byte_string + Format(' code_page %4d  Ord $%2x ',
            [StringCodePage(l_raw_byte_string), Ord(l_raw_byte_string[1])]));

        l_ansi_ibm := #$C6;
        display('ansi_ibm:= $C6 :'+ l_ansi_ibm + Format(' code_page %4d  Ord $%2x ',
            [StringCodePage(l_ansi_ibm), Ord(l_ansi_ibm[1])]));

        l_raw_byte_string:= l_ansi_ibm;
        display('raw:= ibm      :'+ l_raw_byte_string + Format(' code_page %4d  Ord $%2x ',
            [StringCodePage(l_raw_byte_string), Ord(l_raw_byte_string[1])]));

        l_ansi_string := #$C6;
        display('ansi :=  $C6   :'+ l_ansi_string + Format(' code_page %4d  Ord $%2x ',
            [StringCodePage(l_ansi_string), Ord(l_ansi_string[1])]));

        l_raw_byte_string:=  l_ansi_string;
        display('raw:= ansi     :'+ l_raw_byte_string + Format(' code_page %4d  Ord $%2x ',
            [StringCodePage(l_raw_byte_string), Ord(l_raw_byte_string[1])]));
      end; // raw_byte_string_Click

    type t_latin_1_oem= type AnsiString(850);

    procedure TForm1.ibm_437_Click(Sender: TObject);
      var l_ansi_ibm: t_ansi_ibm_oem;
          l_latin_1_oem: t_latin_1_oem;
          l_ansi_string: AnsiString;
          l_unicode_string: UnicodeString;

          l_row, l_column, l_index: Integer;
          l_string: String;
      begin
        DefaultSystemCodePage := 1252;
        with StringGrid1 do
        begin
          l_ansi_ibm:= '';
          l_ansi_string:= '';
          l_latin_1_oem:= '';
          l_unicode_string:= '';

          for l_column:= 0 to 15 do
            Cells[l_column+ 1, 0]:= '$'+ IntToHex(l_column, 2);

          for l_row:= 0 to 15 do
            for l_column:= 0 to 15 do
            begin
              Cells[0, l_row+ 1]:= '$'+ IntToHex(l_row, 2);

              l_index:= l_row* 16+ l_column;

              l_ansi_ibm:= l_ansi_ibm+ Chr(l_index);
              l_latin_1_oem:= l_latin_1_oem+ Chr(l_index);
              l_ansi_string:= l_ansi_string+ Chr(l_index);
              l_unicode_string:= l_unicode_string+ Chr(l_index);

              // l_ansi_ibm[1+ $C6]:= Chr($C6);

(*
              if ibm_437_.Checked
                then Cells[l_column+ 1, l_row+ 1]:= l_ansi_ibm[l_row* 16+ l_column+ 1]
                else Cells[l_column+ 1, l_row+ 1]:= l_ansi_string[l_row* 16+ l_column+ 1];
*)
              if ibm_437_.Checked
                then l_string:= l_ansi_ibm[l_index+ 1] else
              if default_1252_.Checked
                then l_string:= l_ansi_string[l_index+ 1] else
(*
              if unicode_1200_.Checked
                then l_string:= l_latin_1_oem[l_index+ 1] else
*)
              if unicode_1200_.Checked
                then l_string:= l_unicode_string[l_index+ 1] else
                ;

              Cells[l_column+ 1, l_row+ 1]:= l_string;
            end;

          l_ansi_ibm:= #$C6;
          // Cells[7, $D]:= l_ansi_ibm;
          display('#$C6 '+ l_ansi_ibm);
          do_display_ansi_string(AnsiString(l_ansi_ibm));
          do_display('#$C6 '+ l_ansi_ibm);
          l_ansi_ibm:= '';
          display(l_ansi_ibm);

          l_string:= l_ansi_ibm;
          do_display(l_string);

          display('#$C6  '+ #$C6);
        end;
      end;

    procedure TForm1.Button1Click(Sender: TObject);
      var l_save_default_system_codepage: Word;

          l_ansi_ibm: t_ansi_ibm_oem;
          l_ansi_string: AnsiString;
      begin
        l_save_default_system_codepage:= DefaultSystemCodePage;
        DefaultSystemCodePage:= 1252;

        l_ansi_ibm:= #$C6;
        // display('ibm := $C6      :'+ l_ansi_ibm+ Format(' code_page %4d  Ord $%2x ', [ StringCodePage(l_ansi_ibm), Ord(l_ansi_ibm[1])]));
        do_display_ansi_string(AnsiString(l_ansi_ibm));

        l_ansi_string:= l_ansi_ibm;
        // display('ansi := ibm     :'+ l_ansi_string+ Format(' code_page %4d  Ord $%2x ', [ StringCodePage(l_ansi_string), Ord(l_ansi_string[1])]));
        do_display_ansi_string(AnsiString(l_ansi_string));

        l_ansi_ibm:= l_ansi_string;
        // display('ibm := ansi     :'+ l_ansi_ibm+ Format(' code_page %4d  Ord $%2x ', [ StringCodePage(l_ansi_ibm), Ord(l_ansi_ibm[1])]));
        do_display_ansi_string(AnsiString(l_ansi_ibm));

(*
        l_ansi_string:= #$C6;
        display('ansi := $C6     :'+ l_ansi_string+ Format(' code_page %4d  Ord $%2x ', [ StringCodePage(l_ansi_string), Ord(l_ansi_string[1])]));
*)
        DefaultSystemCodePage:= l_save_default_system_codepage;
      end;


    end.

